############################################################################
#                                                                          #
#   Copyright (C) 2011 Po-Hsien Lee <p.lee@mx.uni-saarland.de>             #
#   All rights reserved.                                                   #
#                                                                          #
#   This file is part of PROPORES.                                         #
#                                                                          #
#   PROPORES is free software: you can redistribute it and/or modify       #
#   it under the terms of the GNU General Public License as published by   #
#   the Free Software Foundation, either version 3 of the License, or      #
#   (at your option) any later version.                                    #
#                                                                          #
#   PROPORES is distributed in the hope that it will be useful,            #
#   but WITHOUT ANY WARRANTY; without even the implied warranty of         #
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          #
#   GNU General Public License for more details.                           #
#                                                                          #
#   You should have received a copy of the GNU General Public License      #
#   along with this program.  If not, see <http://www.gnu.org/licenses/>.  #
#                                                                          #
############################################################################
#!/usr/bin/perl


package Dihedral;
no strict;

### Building blocks of dihedral definitions of side chain in PDB nomenclature
@dang1=("N","CA","CB","CG"); 
@dang1_1=("N","CA","CB","CG1");
@dang1_2=("N","CA","CB","SG");
@dang1_3=("N","CA","CB","OG");
@dang1_4=("N","CA","CB","OG1");

@dang2=("CA","CB","CG","CD");
@dang2_1=("CA","CB","CG","SD");
@dang2_2=("CA","CB","CG","OD1");
@dang2_3=("CA","CB","CG","ND1");
@dang2_4=("CA","CB","CG1","CD1");
@dang2_5=("CA","CB","CG","CD1");

@dang3=("CB","CG","CD","NE");
@dang3_1=("CB","CG","CD","CE");
@dang3_2=("CB","CG","CD","OE1");
@dang3_3=("CB","CG","SD","CE");

@dang4=("CG","CD","NE","CZ");
@dang4_1=("CG","CD","CE","NZ");


### definition of dihedral angles of protein residues 
%definition=( 
	"ARG"=>
	[
		[@dang1],	# chi 1
		[@dang2],	# chi 2
		[@dang3],	# chi 3
		[@dang4],	# chi 4
	],

	"LYS"=>
	[
		[@dang1],
		[@dang2],
		[@dang3_1],
		[@dang4_1],
	],

	"GLN"=>
	[
		[@dang1],
		[@dang2],
		[@dang3_2],
	],
	
	"GLU"=>
	[
		[@dang1],
		[@dang2],
		[@dang3_2],
	],

	"MET"=>
	[
		[@dang1],
		[@dang2_1],
		[@dang3_3],
	],

	"ASN"=>
	[
		[@dang1],
		[@dang2_2],
	],

	"ASP"=>
	[
		[@dang1],
		[@dang2_2],
	],

	"HIS"=>
	[
		[@dang1],
		[@dang2_3],
	],

	"ILE"=>
	[
		[@dang1_1],
		[@dang2_4],
	],

	"LEU"=>
	[
		[@dang1],
		[@dang2_5],
	],

	"PHE"=>
	[
		[@dang1],
		[@dang2_5],
	],

	"PRO"=>
	[
		[@dang1],
		[@dang2],
	],

	"TRP"=>
	[
		[@dang1],
		[@dang2_5],
	],

	"TYR"=>
	[
		[@dang1],
		[@dang2_5],
	],

	"CYS"=>
	[
		[@dang1_2],
	],

	"SER"=>
	[
		[@dang1_3],
	],

	"THR"=>
	[
		[@dang1_4],
	],

	"VAL"=>
	[
		[@dang1_1],
	],
);

return(1);

